from enum import Enum
from aenum import MultiValueEnum

from ws_metrics.reporting.templates.capability_report_template import CapabilityReportTemplate
from ws_metrics.reporting.templates.download_report_template import DownloadReportTemplate
from ws_metrics.reporting.templates.operations_report_template import OperationsReportTemplate


class ReportEnum(MultiValueEnum):
    """
    Enum that specifies the types of reports WS Metrics can generate
    """

    _init_ = "value title template_type"

    OPERATIONS = 0, "Operations_Report", OperationsReportTemplate()
    DOWNLOAD = 1, "Download_Report", DownloadReportTemplate()
    CAPABILITY = 2, "Capability_Report", CapabilityReportTemplate()


class FetchType(Enum):
    ONE = 1
    ALL = 2
